using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using NationalInstruments.VisaNS;

namespace NationalInstruments.Examples.SimpleReadWrite
{
    /// <summary>
    /// Summary description for SelectResource.
    /// </summary>
    public class SelectResource : System.Windows.Forms.Form
    {
        private System.Windows.Forms.ListBox availableResources;
        private System.Windows.Forms.Button ok;
        private System.Windows.Forms.Button cancel;
        private System.Windows.Forms.TextBox visaResourceName;
        private System.Windows.Forms.Label AvailableResourcesLabel;
        private System.Windows.Forms.Label ResourceStringLabel;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public SelectResource()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if(components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SelectResource));
			this.availableResources = new System.Windows.Forms.ListBox();
			this.ok = new System.Windows.Forms.Button();
			this.cancel = new System.Windows.Forms.Button();
			this.visaResourceName = new System.Windows.Forms.TextBox();
			this.AvailableResourcesLabel = new System.Windows.Forms.Label();
			this.ResourceStringLabel = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// availableResources
			// 
			this.availableResources.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.availableResources.Location = new System.Drawing.Point(5, 18);
			this.availableResources.Name = "availableResources";
			this.availableResources.Size = new System.Drawing.Size(282, 108);
			this.availableResources.TabIndex = 0;
			this.availableResources.DoubleClick += new System.EventHandler(this.availableResources_DoubleClick);
			this.availableResources.SelectedIndexChanged += new System.EventHandler(this.availableResources_SelectedIndexChanged);
			// 
			// ok
			// 
			this.ok.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.ok.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.ok.Location = new System.Drawing.Point(5, 187);
			this.ok.Name = "ok";
			this.ok.Size = new System.Drawing.Size(77, 25);
			this.ok.TabIndex = 2;
			this.ok.Text = "OK";
			// 
			// cancel
			// 
			this.cancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancel.Location = new System.Drawing.Point(82, 187);
			this.cancel.Name = "cancel";
			this.cancel.Size = new System.Drawing.Size(77, 25);
			this.cancel.TabIndex = 3;
			this.cancel.Text = "Cancel";
			// 
			// visaResourceName
			// 
			this.visaResourceName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.visaResourceName.Location = new System.Drawing.Point(5, 157);
			this.visaResourceName.Name = "visaResourceName";
			this.visaResourceName.Size = new System.Drawing.Size(282, 20);
			this.visaResourceName.TabIndex = 4;
			this.visaResourceName.Text = "USB0::0x413C::0x3010::NI-VISA-0::RAW";
			// 
			// AvailableResourcesLabel
			// 
			this.AvailableResourcesLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.AvailableResourcesLabel.Location = new System.Drawing.Point(5, 5);
			this.AvailableResourcesLabel.Name = "AvailableResourcesLabel";
			this.AvailableResourcesLabel.Size = new System.Drawing.Size(279, 12);
			this.AvailableResourcesLabel.TabIndex = 5;
			this.AvailableResourcesLabel.Text = "Available Resources:";
			// 
			// ResourceStringLabel
			// 
			this.ResourceStringLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ResourceStringLabel.Location = new System.Drawing.Point(5, 141);
			this.ResourceStringLabel.Name = "ResourceStringLabel";
			this.ResourceStringLabel.Size = new System.Drawing.Size(279, 13);
			this.ResourceStringLabel.TabIndex = 6;
			this.ResourceStringLabel.Text = "Resource String:";
			// 
			// SelectResource
			// 
			this.AcceptButton = this.ok;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cancel;
			this.ClientSize = new System.Drawing.Size(292, 220);
			this.Controls.Add(this.ResourceStringLabel);
			this.Controls.Add(this.AvailableResourcesLabel);
			this.Controls.Add(this.visaResourceName);
			this.Controls.Add(this.cancel);
			this.Controls.Add(this.ok);
			this.Controls.Add(this.availableResources);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.KeyPreview = true;
			this.MaximizeBox = false;
			this.MinimumSize = new System.Drawing.Size(177, 247);
			this.Name = "SelectResource";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Select Resource";
			this.Load += new System.EventHandler(this.OnLoad);
			this.ResumeLayout(false);

		}
        #endregion


        private void OnLoad(object sender, System.EventArgs e)
        {
            string[] resources = ResourceManager.GetLocalManager().FindResources("USB?*");
            foreach(string s in resources)
            {
                availableResources.Items.Add(s);
            }
            
        }

        private void availableResources_DoubleClick(object sender, System.EventArgs e)
        {
            string selectedString = (string)availableResources.SelectedItem;
            ResourceName = selectedString;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void availableResources_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            string selectedString = (string)availableResources.SelectedItem;
            ResourceName = selectedString;
        }

        public string ResourceName
        {
            get
            {
                return visaResourceName.Text;
            }
            set
            {
                visaResourceName.Text = value;
            }
        }
    }
}
